--- linux-3.10.5/arch/mips/kernel/setup.c	2013-08-04 10:51:49.000000000 +0200
+++ linux-3.10.5.new/arch/mips/kernel/setup.c	2013-08-23 06:53:14.951473493 +0200
@@ -80,6 +80,70 @@ static struct resource data_resource = {
 
 static void *detect_magic __initdata = detect_memory_region;
 
+static void __init test_memory_regions(void) {
+	unsigned char pattern[] = {
+		0x00,
+		0xff,
+		0x55,
+		0xaa,
+		0x11,
+		0x22,
+		0x44,
+		0x88,
+		0x33,
+		0x66,
+		0x99,
+		0xcc,
+		0x77,
+		0xbb,
+		0xdd,
+		0xee,
+	};
+	int p;
+	int i;
+	phys_t c;
+	volatile unsigned char *test;
+	phys_t bad = 0;
+	int x;
+
+	for(p = 0; p < sizeof(pattern) / sizeof(pattern[0]); p++) {
+		for (i = 0; i < boot_mem_map.nr_map; i++) {
+			if (boot_mem_map.map[i].type != BOOT_MEM_RAM)
+				continue;
+
+			memset((void *) boot_mem_map.map[i].addr, pattern[p], boot_mem_map.map[i].size);
+		};
+
+		for (i = 0; i < boot_mem_map.nr_map; i++) {
+			if (boot_mem_map.map[i].type != BOOT_MEM_RAM)
+				continue;
+
+			test = (unsigned char *) boot_mem_map.map[i].addr;
+
+			for (c = 0; c < boot_mem_map.map[i].size; c++) {
+
+				if(test[c] != pattern[p]) {
+					bad++;
+				}
+				else if(bad > 0) {
+					if (boot_mem_map.nr_map < BOOT_MEM_MAP_MAX) {
+						x = boot_mem_map.nr_map;
+						boot_mem_map.map[x].addr = boot_mem_map.map[i].addr + c;
+						boot_mem_map.map[x].size = boot_mem_map.map[i].size - c;
+						boot_mem_map.map[x].type = boot_mem_map.map[i].type;
+						boot_mem_map.nr_map++;
+					} else {
+						pr_err("Ooops! Too many entries in the memory map!\n");
+					}
+
+					boot_mem_map.map[i].size = c - bad;
+					bad = 0;
+				}
+			}
+		}
+	}
+}
+
 void __init add_memory_region(phys_t start, phys_t size, long type)
 {
 	int x = boot_mem_map.nr_map;
@@ -599,6 +663,8 @@ static void __init arch_mem_init(char **
 		print_memory_map();
 	}
 
+	test_memory_regions();
+
 	bootmem_init();
 #ifdef CONFIG_PROC_VMCORE
 	if (setup_elfcorehdr && setup_elfcorehdr_size) {
